# -*- coding: utf-8 -*-

from rest_framework import viewsets
from rest_framework.decorators import action

from thx.api.views import ThuxViewMixin
from thx.role.core.views import ThuxRoleViewSetMixin

from ... import models
from . import serializers


# VAT
class VatViewSet(ThuxRoleViewSetMixin, ThuxViewMixin, viewsets.ModelViewSet):
    queryset = models.Vat.objects.all()
    serializer_class = serializers.VatSerializer

    @action(methods=['patch'], detail=True)
    def enable(self, request, **filters):
        return super().partial_update(request)

    @action(methods=['patch'], detail=True)
    def disable(self, request, **filters):
        return super().partial_update(request)
